package ec.edu.epn.consumosriautorizacion.controller;


import ec.edu.epn.consumosriautorizacion.dto.DetallefacturaDTO;
import ec.edu.epn.consumosriautorizacion.dto.FacturaDTO;
import ec.edu.epn.consumosriautorizacion.dto.FacturacionOfflineDTO;
import ec.edu.epn.consumosriautorizacion.dto.PagosDTO;
import ec.edu.epn.consumosriautorizacion.exceptions.FTPErrors;
import ec.edu.epn.consumosriautorizacion.service.EmailService;
import ec.edu.epn.consumosriautorizacion.service.FTPService;
import ec.gob.sri.comprobantes.ws.RecepcionComprobantesOffline;
import ec.gob.sri.comprobantes.ws.RecepcionComprobantesOfflineService;
import ec.gob.sri.comprobantes.ws.aut.AutorizacionComprobantesOffline;
import ec.gob.sri.comprobantes.ws.aut.AutorizacionComprobantesOfflineService;
import ec.gob.sri.comprobantes.ws.aut.RespuestaComprobante;
import ec.gob.sri.comprobantes.ws.RespuestaSolicitud;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.net.URL;
import javax.xml.namespace.QName;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;

import static java.nio.charset.StandardCharsets.ISO_8859_1;
import static java.nio.charset.StandardCharsets.UTF_8;

@RestController
public class SriAutorizacionController {


	@Autowired
	ConsultasFacturacionController consultas;


	@Autowired
	FTPService ftpService;

	@GetMapping("/pruebas")
	public String pruebas() throws FTPErrors, FileNotFoundException {
		ftpService.connectToFTP();

		//	ConsultasFacturacionController consulta= new ConsultasFacturacionController();
		FacturaDTO facturaDTO= new FacturaDTO();
		List<DetallefacturaDTO> listDetalle= new ArrayList<DetallefacturaDTO>();
		List<PagosDTO> listPagos= new ArrayList<PagosDTO>();
		facturaDTO= consultas.consumoFactura("001-003-0077105");
		listDetalle= consultas.consumoDetalleFact(facturaDTO.getIdFactura());
		listPagos= consultas.consumoPagos(facturaDTO.getIdFactura());
		GeneracionFactOfflinePDF pdf= new GeneracionFactOfflinePDF();

		String attchment= pdf.generarPDFFacturaOffline(facturaDTO, listDetalle, listPagos);


		BufferedInputStream buffIn = null;
		buffIn = new BufferedInputStream(new FileInputStream(attchment));


		ftpService.uploadFileToFTP(buffIn, "1720812633_Facturas", "001-001_german");



		return "PRUEBA EXITOSA";
	}

	@GetMapping("/recepcion/{xml}")
	public FacturacionOfflineDTO recepcion(@PathVariable String xml){

		String val = "";
		FacturacionOfflineDTO offlineDTO = new FacturacionOfflineDTO();

		try {
			RespuestaSolicitud respuesta = new RespuestaSolicitud();

			byte[] bytes = val.getBytes();

			String wsdl = "https://cel.sri.gob.ec/comprobantes-electronicos-ws/RecepcionComprobantesOffline?wsdl";
			URL url = new URL(wsdl);

			QName qname = new QName("http://ec.gob.sri.ws.recepcion", "RecepcionComprobantesOfflineService");

			RecepcionComprobantesOfflineService service = new RecepcionComprobantesOfflineService(url, qname);
			RecepcionComprobantesOffline port = service.getRecepcionComprobantesOfflinePort();  //getRecepcionComprobantesOfflinePort();

			respuesta = port.validarComprobante(bytes);

			/*PARA EL CASO DONDE EL ESTADO SEA NULL**/
			if (respuesta.getEstado() == null) {
				if (respuesta.getComprobantes() != null) {

					try {
						offlineDTO.setMensaje(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getMensaje());
					} catch (Exception e) {
						offlineDTO.setMensaje("NINGUN MENSAJE ENCOTRADO");
					}

					try {
						offlineDTO.setInfoAdicional(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getInformacionAdicional());
					} catch (Exception e) {
						offlineDTO.setInfoAdicional("NO DEFINIDO");
					}

					try {
						offlineDTO.setIdentificador(Integer.valueOf(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getIdentificador()));
					} catch (Exception e) {
						offlineDTO.setIdentificador(0);
					}

					try {
						offlineDTO.setTipo(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getTipo());
					} catch (Exception e) {
						offlineDTO.setTipo("ERROR");
					}

					try {
						offlineDTO.setClaveAcceso(respuesta.getComprobantes().getComprobante().get(0).getClaveAcceso());
					} catch (Exception e) {
						offlineDTO.setClaveAcceso("NO DEFINIDO");
					}

					offlineDTO.setEstado("DEVUELTA - SN");

				}
			}

			if (respuesta.getEstado().equals("DEVUELTA")) {
				try {
					offlineDTO.setMensaje(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getMensaje());
				} catch (Exception e) {
					offlineDTO.setMensaje("NINGUN MENSAJE ENCOTRADO");
				}

				try {
					offlineDTO.setInfoAdicional(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getInformacionAdicional());
				} catch (Exception e) {
					offlineDTO.setInfoAdicional("NO DEFINIDO");
				}

				try {
					offlineDTO.setIdentificador(Integer.valueOf(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getIdentificador()));
				} catch (Exception e) {
					offlineDTO.setIdentificador(0);
				}

				try {
					offlineDTO.setTipo(respuesta.getComprobantes().getComprobante().get(0).getMensajes().getMensaje().get(0).getTipo());
				} catch (Exception e) {
					offlineDTO.setTipo("ERROR");
				}

				try {
					offlineDTO.setClaveAcceso(respuesta.getComprobantes().getComprobante().get(0).getClaveAcceso());
				} catch (Exception e) {
					offlineDTO.setClaveAcceso("NO DEFINIDO");
				}

				offlineDTO.setEstado("DEVUELTA");
			}

			if (respuesta.getEstado().equals("RECIBIDA")) {
				offlineDTO.setEstado("RECIBIDA");
			}

			System.out.println("ESTADO FACTURA  " + respuesta.getEstado());

			return offlineDTO;

		} catch (Exception e) {

			return new FacturacionOfflineDTO();
		}
	}



	@GetMapping("/autorizacion/{numAutorizacion}")
	public FacturacionOfflineDTO autorizacion(@PathVariable String numAutorizacion){
		FacturacionOfflineDTO offlineDTO = new FacturacionOfflineDTO();

		try {

			String wsdl = "https://cel.sri.gob.ec/comprobantes-electronicos-ws/AutorizacionComprobantesOffline?wsdl";
			URL url = new URL(wsdl);
			QName qname = new QName("http://ec.gob.sri.ws.autorizacion", "AutorizacionComprobantesOfflineService");
			AutorizacionComprobantesOfflineService services = new AutorizacionComprobantesOfflineService(new URL(wsdl), qname);
			AutorizacionComprobantesOffline port = services.getAutorizacionComprobantesOfflinePort();


			RespuestaComprobante respuesta = port.autorizacionComprobante(numAutorizacion);

			if(respuesta.getAutorizaciones()!=null){

				if(respuesta.getAutorizaciones().getAutorizacion().get(0).getEstado().equals("AUTORIZADO")){
					offlineDTO.setAmbiente("PRODUCCION");
					offlineDTO.setEstado("AUTORIZADO");

					try {
						respuesta.getAutorizaciones().getAutorizacion().get(0).getFechaAutorizacion().toGregorianCalendar().setTimeZone(TimeZone.getTimeZone("ECT"));
						offlineDTO.setFechaAutorizacion(Timestamp.valueOf(respuesta.getAutorizaciones().getAutorizacion().get(0).getFechaAutorizacion().toGregorianCalendar().getTimeZone().toString()));
					} catch (Exception e) {

						Calendar cal = Calendar.getInstance();
						Date fechaHoy= cal.getTime();
						String DATE_FORMAT = "yyyy-MM-dd hh:mm:ss";
						TimeZone timeZone = TimeZone.getTimeZone("ECT");
						SimpleDateFormat formatterWithTimeZone = new SimpleDateFormat(DATE_FORMAT);
						formatterWithTimeZone.setTimeZone(timeZone);
						String sDate = formatterWithTimeZone.format(fechaHoy);
						SimpleDateFormat formatter = new SimpleDateFormat(DATE_FORMAT);
						Date dateWithTimeZone = formatter.parse(sDate);




						offlineDTO.setFechaAutorizacion(new Timestamp(dateWithTimeZone.getTime()));
					}

				}

				if(!respuesta.getAutorizaciones().getAutorizacion().get(0).getEstado().equals("AUTORIZADO")){

					offlineDTO.setAmbiente("PRODUCCION");
					offlineDTO.setEstado("NO AUTORIZADO -ND");
					try {
						offlineDTO.setMensaje(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getMensaje());
					} catch (Exception e) {
						offlineDTO.setMensaje("NO DEFIIDO");
					}


					try {
						offlineDTO.setIdentificador(Integer.valueOf(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getIdentificador()));
					} catch (Exception e) {
						offlineDTO.setIdentificador(0);
					}


					try {
						offlineDTO.setTipo(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getTipo());
					} catch (Exception e) {
						offlineDTO.setTipo("NO DEFINIDO");
					}

					try {
						offlineDTO.setInfoAdicional(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getInformacionAdicional());
					} catch (Exception e) {
						offlineDTO.setInfoAdicional("NINGNUNO");
					}
				}
			}

			if(respuesta.getNumeroComprobantes().equals("0")){
				offlineDTO.setAmbiente("PRODUCCION");
				offlineDTO.setEstado("NO AUTORIZADO SIN ENVIO RECEPCION");
				offlineDTO.setMensaje("NO DEFIIDO");
				offlineDTO.setTipo("NO DEFINIDO");
				offlineDTO.setInfoAdicional("NINGNUNO");
			}

			return offlineDTO;

		} catch (Exception e) {
			FacturacionOfflineDTO offlineDTOerror = new FacturacionOfflineDTO();

			offlineDTOerror.setMensaje(e.getMessage());
			return offlineDTOerror;
		}
	}

	@GetMapping("/envioCorreo/{correo}")
	public FacturacionOfflineDTO envioCorreo(@PathVariable String correo) {
		FacturacionOfflineDTO offlineDTO = new FacturacionOfflineDTO();

		try {

			java.util.List<String> para = new ArrayList<String>();



			para.add(correo);
			String hoyFecha = "";
			DateFormat fecha = new SimpleDateFormat("yyyy/MM/dd");
			Date hoy = new Date();

			hoyFecha = fecha.format(hoy);

			String de = "<facturacion.electronica@epn.edu.ec>";
			String subject = "EPN FACTURA ELECTRÓNICA";
			// Cuerpo mensaje

			String cabecera = "<HTML><BODY>  <p align='center' style='margin-right:50px;'> <img src='https://cem.epn.edu.ec/imagenes/logos_institucionales/big_jpg/EPN_logo_big.jpg' width= '300' height='150' style='margin-right:50px;' /> <br/> <br/>";
			String cuerpo = "<p align='center' style='margin-right:50px;'>" + "<b>Estimado(a): </b> <br/>"
					+ "GERMAN ROMERO" + "<br/>"
					+ "<b>Una nueva Factura Electrónica está disponible para usted  </b><br/>"
					+ "<b>REFERENCIAS </b> <br/>" + "<b>Factura Número: </b>  001-001-000001 <br/>"
					+ "<b>Total Factura: </b> 50 USD <br/>"
					+ "<b>Fecha Factura: </b>" + hoyFecha + " <br/>" + "<b>Ambiente: </b> PRODUCCION <br/>"
					+ "<b>Estado: </b> PRUEBAS <br/>" + "<b>Clave de Acceso: </b>"
					+  " <br/>";

			String pie = "<br/> <br/> <img src='cid:cidpie' style='margin-right:50px;'/></BODY></HTML>";



			EmailService emailService= new EmailService();

			byte[] ptext =  emailService.remplazarCaracteresHTML(cuerpo).getBytes(ISO_8859_1);
			String cuerpoF = new String(ptext, UTF_8);

			String text = cabecera + cuerpoF + pie;

			java.util.List<String> adjuntos = new ArrayList<String>();


		//	ConsultasFacturacionController consulta= new ConsultasFacturacionController();
			FacturaDTO facturaDTO= new FacturaDTO();
			List<DetallefacturaDTO> listDetalle= new ArrayList<DetallefacturaDTO>();
			List<PagosDTO> listPagos= new ArrayList<PagosDTO>();
			facturaDTO= consultas.consumoFactura("001-003-0077105");
			listDetalle= consultas.consumoDetalleFact(facturaDTO.getIdFactura());
			listPagos= consultas.consumoPagos(facturaDTO.getIdFactura());
			GeneracionFactOfflinePDF pdf= new GeneracionFactOfflinePDF();

			String attchment= pdf.generarPDFFacturaOffline(facturaDTO, listDetalle, listPagos);




			emailService.sendEmail(para, subject, text, attchment);

			offlineDTO.setMensaje("CORREO ENVIADO CORRECTAMENTE");
			return offlineDTO;

		}catch (Exception e){

			FacturacionOfflineDTO offlineDTOerror = new FacturacionOfflineDTO();

			offlineDTOerror.setMensaje(e.getMessage());
			return offlineDTOerror;

		}







	}


}
